include \masm32\include\masm32rt.inc
.686p
.mmx
.xmm

WndProc proto hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

RegisterDragContainerClass proto
CreateWindowExC proto c dwExStyle:DWORD,lpClassName:PCHAR,lpWindowName:PCHAR,dwStyle:DWORD,x:SDWORD,y:SDWORD,nWidth:SDWORD,nHeight:SDWORD,hWndParent:HWND,hMenu:HMENU,hInst:HINSTANCE,lpParam:LPVOID,a:DWORD,nMessages:DWORD,uMessages:VARARG

WND_DATA struct
	hBtn	HWND	?
	hEdt	HWND	?
	hList	HWND	?
WND_DATA ends

DC_DATA struct
	a				DWORD	?	; size of handholds , [a]=pixel
	hCntrl			HWND	?	; target control (-> child control of this container)

	bDrag			DWORD	?	; dragging related var's
	index			DWORD	?	;
	ptDown			POINT	<>	;

	nMessages		DWORD	?
	pMessages		PDWORD	?	; messages which should be forwarded to the parent window

	MSG_FORWARDING	DWORD	?	; global message used by the container control
DC_DATA ends

.data?
	hInstance	dd ?
.code
main proc 
LOCAL wcex:WNDCLASSEX
LOCAL msg:MSG
	
	fn MessageBox,0,"The controls can be moved by holding the CONTROL-key down while dragging the handholds (white boxes)","Info",0

	; register class for container control
	invoke RegisterDragContainerClass

	mov hInstance,rv(GetModuleHandle,0)
	mov wcex.hInstance,eax
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET WndProc
	mov wcex.cbClsExtra,0
	mov wcex.cbWndExtra,SIZEOF WND_DATA
	mov wcex.hbrBackground,rv(GetStockObject,GRAY_BRUSH)
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,chr$("win32class")
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx, ADDR wcex
	mov esi,rv(CreateWindowEx,0,wcex.lpszClassName,"Win32App",WS_VISIBLE or WS_SYSMENU or WS_SIZEBOX or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_CLIPCHILDREN,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,0,0,hInstance,0)

	.while 1
		invoke GetMessage,ADDR msg,NULL,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw

	invoke ExitProcess,msg.wParam

main endp

WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL sz[128]:CHAR

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_DESTROY
	.elseif uMsg == WM_CREATE
		
		;/* create controls  */
		
		; handholds-size=6pix, WM_COMMAND should be forwarded to our WndProc
		mov esi,rv(CreateWindowExC,0,"Button","add text",WS_CHILD or WS_VISIBLE,10,10,100,100,hWnd,0,hInstance,0,6,1,WM_COMMAND)
		invoke SetWindowLong,hWnd,WND_DATA.hBtn,esi

		mov esi,rv(CreateWindowExC,0,"Edit","123 Test",WS_CHILD or WS_VISIBLE or ES_AUTOHSCROLL,120,10,100,100,hWnd,0,hInstance,0,7,1,WM_COMMAND)
		invoke SetWindowLong,hWnd,WND_DATA.hEdt,esi
		
		mov esi,rv(CreateWindowExC,0,"ListBox",0,WS_CHILD or WS_VISIBLE or LBS_DISABLENOSCROLL,10,160,200,200,hWnd,0,hInstance,0,8,0)
		invoke SetWindowLong,hWnd,WND_DATA.hList,esi

	.elseif uMsg == WM_COMMAND
		mov esi,lParam
		.if esi == rv(GetWindowLong,hWnd,WND_DATA.hBtn)
			.if WORD ptr wParam+2 == BN_CLICKED
				mov esi,rv(GetWindowLong,hWnd,WND_DATA.hEdt)
				mov edi,rv(GetWindowLong,hWnd,WND_DATA.hList)
				invoke GetWindowText,esi,ADDR sz,128
				invoke SendMessage,edi,LB_ADDSTRING,0,ADDR sz
			.endif
		.else
			.if esi == rv(GetWindowLong,hWnd,WND_DATA.hEdt)
				.if WORD ptr wParam+2 == EN_CHANGE
					invoke GetWindowText,esi,ADDR sz,128
					invoke SetWindowText,hWnd,ADDR sz
				.endif
			.endif
		.endif
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
WndProc endp

align 16
RegisterDragContainerClass proc
LOCAL wcex:WNDCLASSEX

	mov wcex.hInstance,rv(GetModuleHandle,0)
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET DragContainer
	mov wcex.cbClsExtra,0
	mov wcex.cbWndExtra,SIZEOF DC_DATA
	mov wcex.hbrBackground,rv(GetStockObject,WHITE_BRUSH)
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,chr$("DragContainer32")
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx, ADDR wcex
	
	ret
	
RegisterDragContainerClass endp

;---------------------------------------------------------------------------------
; Creates a drag-container and adds the requested child control to it.
; The last three parameters are related to the container control:
; a: size of handholds (pixel)
; nMessages: number of VARARGs
; uMessages: = VARARG = messages which are forwarded to the parent hWndParent
;---------------------------------------------------------------------------------
align 16
CreateWindowExC proc c dwExStyle:DWORD,lpClassName:PCHAR,lpWindowName:PCHAR,dwStyle:DWORD,x:SDWORD,y:SDWORD,nWidth:SDWORD,nHeight:SDWORD,hWndParent:HWND,hMenu:HMENU,hInst:HINSTANCE,lpParam:LPVOID,a:DWORD,nMessages:DWORD,uMessages:VARARG
LOCAL hContainer:HWND
LOCAL hCntrl:HWND	
	
	mov eax,a
	lea eax,[eax*2]
	.if nWidth < eax
		mov nWidth,eax
	.endif
	.if nHeight < eax
		mov nHeight,eax
	.endif
	mov hContainer,rv(CreateWindowEx,0,"DragContainer32",0,WS_VISIBLE or WS_CHILD or WS_CLIPCHILDREN or WS_CLIPSIBLINGS,x,y,nWidth,nHeight,hWndParent,0,hInst,a)
	.if !hContainer
		ret
	.endif
	
	mov eax,a
	lea eax,[eax*2]
	mov ecx,nWidth
	mov edx,nHeight
	sub ecx,eax
	sub edx,eax
	mov hCntrl,rv(CreateWindowEx,dwExStyle,lpClassName,lpWindowName,dwStyle,0,0,ecx,edx,hContainer,hMenu,hInst,lpParam)
	.if !hCntrl
		invoke DestroyWindow,hContainer
		xor eax,eax
		ret
	.endif
	invoke SetWindowLong,hContainer,DC_DATA.hCntrl,hCntrl
	
	mov edx,rv(RegisterWindowMessage,"DCM_MSG_FORWARDING")
	.if nMessages
		invoke SendMessage,hContainer,edx,nMessages,ADDR uMessages
	.endif
	
	mov eax,hCntrl
	ret
	
CreateWindowExC endp

align 16
GetHandHoldsRect proc uses edi esi hWnd:HWND,a:DWORD,pRect: ptr RECT
LOCAL rect[8]:RECT

; handholds:
;            0---7---6
;            |       |
;            1       5
;            |       |
;            2---3---4
;
	invoke RtlZeroMemory,ADDR rect[16],(SIZEOF RECT)*7
	invoke GetWindowRect,hWnd,ADDR rect
	mov esi,rect.right
	mov edi,rect.bottom
	sub esi,rect.left  ; width
	sub edi,rect.top   ; height
	mov edx,a          ; a
	mov ecx,edx
	shr ecx,1          ; 0.5*a

	mov rect.left,0
	mov rect.top,0
	
	; y: 0 & 7 & 6
	mov rect[0*16].bottom,edx
	mov rect[6*16].bottom,edx
	mov rect[7*16].bottom,edx
	
	; y: 1 & 5
	mov eax,edi
	shr eax,1
	sub eax,ecx
	mov rect[1*16].top,eax
	mov rect[5*16].top,eax
	lea eax,[eax+edx]
	mov rect[1*16].bottom,eax
	mov rect[5*16].bottom,eax

    ; y: 2 & 3 & 4
	mov eax,edi
	sub eax,edx
	mov rect[2*16].top,eax
	mov rect[3*16].top,eax
	mov rect[4*16].top,eax
	mov rect[2*16].bottom,edi
	mov rect[3*16].bottom,edi
	mov rect[4*16].bottom,edi
	
	; x: 0 & 1 & 2
	mov rect[0*16].right,edx
	mov rect[1*16].right,edx
	mov rect[2*16].right,edx
	
	; x: 3 & 7
	mov eax,esi
	shr eax,1
	sub eax,ecx
	mov rect[3*16].left,eax
	mov rect[7*16].left,eax
	lea eax,[eax+edx]
	mov rect[3*16].right,eax
	mov rect[7*16].right,eax
	
	; x: 4 & 5 & 6
	mov eax,esi
	sub eax,edx
	mov rect[4*16].left,eax
	mov rect[5*16].left,eax
	mov rect[6*16].left,eax
	mov rect[4*16].right,esi
	mov rect[5*16].right,esi
	mov rect[6*16].right,esi
	
	invoke RtlMoveMemory,pRect,ADDR rect,(SIZEOF RECT)*8
	mov eax,1
	ret
	
GetHandHoldsRect endp

align 16
DrawHandHolds proc uses ebx esi edi hWnd:HWND,a:DWORD
LOCAL hdc:HDC
LOCAL rect[8]:RECT

	invoke GetHandHoldsRect,hWnd,a,ADDR rect
	
	mov hdc,rv(GetWindowDC,hWnd)

	mov ebx,rv(GetStockObject,BLACK_BRUSH)
	mov edi,LENGTHOF rect
	lea esi,rect
	.while edi
		invoke BitBlt,hdc,[esi].RECT.left,[esi].RECT.top,a,a,hdc,0,0,PATCOPY
		invoke FrameRect,hdc,esi,ebx
		lea esi,[esi+SIZEOF RECT]
		lea edi,[edi-1]
	.endw

	invoke ReleaseDC,hWnd,hdc

	ret
	
DrawHandHolds endp

; uses screen coord.
; return: index of handhold {0...7} or -1 if no hit
align 16
HandHoldsHitTest proc uses edi esi ebx hWnd:DWORD,a:DWORD,x:DWORD,y:DWORD
LOCAL rect[9]:RECT	
	
	invoke GetHandHoldsRect,hWnd,a,ADDR rect
	
	invoke GetWindowRect,hWnd,ADDR rect[8*16]
	lea esi,rect
	xor edi,edi
	mov ecx,rect[8*16].left
	mov edx,rect[8*16].top
	.while edi < 8
		add [esi].RECT.left,ecx
		add [esi].RECT.top,edx
		add [esi].RECT.right,ecx
		add [esi].RECT.bottom,edx
		push ecx
		push edx
		invoke PtInRect,esi,x,y
		.if eax
			add esp,8
			mov eax,edi
			ret
		.endif
		pop edx
		pop ecx
		lea esi,[esi+SIZEOF RECT]
		lea edi,[edi+1]
	.endw
	mov eax,-1	
	ret
	
HandHoldsHitTest endp

align 16
ResizeCntrl proc uses ebx esi edi hWnd:HWND,index:DWORD,a:DWORD,_dx:DWORD,dy:DWORD
LOCAL rect:RECT

	invoke GetWindowRect,hWnd,ADDR rect
	mov ebx,rv(GetParent,hWnd)
	invoke ScreenToClient,ebx,ADDR rect.left
	invoke ScreenToClient,ebx,ADDR rect.right
	mov esi,_dx
	mov edi,dy
	
	.if index == 0
		add rect.left,esi
		add rect.top,edi
	.elseif index == 1
		add rect.left,esi
	.elseif index == 2
		add rect.left,esi
		add rect.bottom,edi
	.elseif index == 3
		add rect.bottom,edi
	.elseif index == 4
		add rect.right,esi
		add rect.bottom,edi
	.elseif index == 5
		add rect.right,esi
	.elseif index == 6
		add rect.right,esi
		add rect.top,edi
	.elseif index == 7
		add rect.top,edi
	.endif
	mov esi,rect.right
	mov edi,rect.bottom
	sub esi,rect.left
	sub edi,rect.top
	
	mov ecx,a
	lea eax,[ecx*2+ecx]
	.if SDWORD ptr esi < eax
		.if index == 0 ||index == 1 || index == 2
			m2m rect.left,rect.right
			sub rect.left,eax
		.elseif index == 4 || index == 5 || index == 6
			m2m rect.right,rect.left
			add rect.right,eax
		.endif
	.endif
	.if SDWORD ptr edi < eax
		.if index == 0 ||index == 7 || index == 6
			m2m rect.top,rect.bottom
			sub rect.top,eax
		.elseif index == 2 || index == 3 || index == 4
			m2m rect.bottom,rect.top
			add rect.bottom,eax
		.endif
	.endif

	mov esi,rect.right
	mov edi,rect.bottom
	sub esi,rect.left
	sub edi,rect.top
	
	invoke MoveWindow,hWnd,rect.left,rect.top,esi,edi,1
	ret
	
ResizeCntrl endp

align 16
CreateRegion proc uses edi esi ebx hWnd:HWND,a:DWORD
LOCAL rect[8]:RECT

	invoke GetWindowRect,hWnd,ADDR rect
	mov ecx,rect.right
	mov edx,rect.bottom
	sub ecx,rect.left
	sub edx,rect.top
	sub ecx,a
	sub edx,a
	mov edi,rv(CreateRectRgn,a,a,ecx,edx)

	invoke GetHandHoldsRect,hWnd,a,ADDR rect
	
	lea esi,rect
	xor ebx,ebx
	.while ebx <8
		
		push rv(CreateRectRgn,[esi].RECT.left,[esi].RECT.top,[esi].RECT.right,[esi].RECT.bottom)
		invoke CombineRgn,edi,edi,eax,RGN_OR
		pop edx
		invoke DeleteObject,edx
		lea esi,[esi+SIZEOF RECT]
		lea ebx,[ebx+1]
	.endw
	
	mov eax,edi
	ret
	
CreateRegion endp

align 16
DragContainer proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL ps:PAINTSTRUCT
LOCAL rect[8]:RECT
LOCAL bUpdatePos:DWORD
LOCAL hdc:HDC
LOCAL pt[2]:POINT

	; message forwarding
	.if rv(GetWindowLong,hWnd,DC_DATA.pMessages)
		mov esi,eax
		mov edi,rv(GetParent,hWnd)
		mov ebx,rv(GetWindowLong,hWnd,DC_DATA.nMessages)
		mov edx,uMsg
		xor ecx,ecx
		.while ecx < ebx
			.if DWORD ptr [esi+ecx*4] == edx
				invoke SendMessage,edi,uMsg,wParam,lParam
				ret
			.endif
			lea ecx,[ecx+1]
		.endw
	.endif

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_DESTROY
		.if rv(GetWindowLong,hWnd,DC_DATA.pMessages)
			free eax
		.endif
	.elseif uMsg == WM_NCCREATE
		invoke SetWindowLong,hWnd,DC_DATA.MSG_FORWARDING,rv(RegisterWindowMessage,"DCM_MSG_FORWARDING")
		mov esi,lParam
		invoke SetWindowLong,hWnd,DC_DATA.a,[esi].CREATESTRUCT.lpCreateParams
		mov eax,1
		ret
	.elseif uMsg == WM_NCCALCSIZE
		mov ebx,rv(GetWindowLong,hWnd,DC_DATA.a)
		mov esi,lParam
		add [esi].RECT.left,ebx
		add [esi].RECT.top,ebx
		sub [esi].RECT.right,ebx
		sub [esi].RECT.bottom,ebx
		mov eax,0
		ret
	.elseif uMsg == WM_NCHITTEST
		mov ebx,rv(GetWindowLong,hWnd,DC_DATA.a)
		movsx ecx,SWORD ptr lParam
		movsx edx,SWORD ptr lParam+2
		.if rv(HandHoldsHitTest,hWnd,ebx,ecx,edx) != -1
			mov eax,HTBORDER
			ret
		.else
			invoke GetWindowRect,hWnd,ADDR rect
			add rect.left,ebx
			add rect.top,ebx
			sub rect.right,ebx
			sub rect.bottom,ebx
			movsx ecx,SWORD ptr wParam
			movsx edx,SWORD ptr wParam+2
			.if rv(PtInRect,ADDR rect,ecx,edx)
				mov eax,HTCLIENT
			.else
				xor eax,eax
			.endif
			ret
		.endif
		
	.elseif uMsg == WM_NCLBUTTONDOWN
		invoke GetCursorPos,ADDR pt
		mov ebx,rv(GetWindowLong,hWnd,DC_DATA.bDrag)
		.if rv(HandHoldsHitTest,hWnd,rv(GetWindowLong,hWnd,DC_DATA.a),pt.x,pt.y) != -1 && !ebx
			invoke SetWindowLong,hWnd,DC_DATA.index,eax
			invoke SetWindowPos,hWnd,HWND_TOP,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE
			invoke SetCapture,hWnd
			invoke SetWindowLong,hWnd,DC_DATA.bDrag,1
			invoke SetWindowLong,hWnd,DC_DATA.ptDown.x,pt.x
			invoke SetWindowLong,hWnd,DC_DATA.ptDown.y,pt.y
		.else
			invoke DefWindowProc,hWnd,uMsg,wParam,lParam
			ret
		.endif
	.elseif uMsg == WM_NCMOUSEMOVE || uMsg == WM_MOUSEMOVE
		.if rv(GetWindowLong,hWnd,DC_DATA.bDrag)
			invoke GetCursorPos,ADDR pt
			mov esi,rv(GetWindowLong,hWnd,DC_DATA.ptDown.x)
			mov edi,rv(GetWindowLong,hWnd,DC_DATA.ptDown.y)
			sub pt.x,esi
			sub pt.y,edi
			.if pt.x || pt.y
				invoke GetCursorPos,ADDR pt[8]
				invoke SetWindowLong,hWnd,DC_DATA.ptDown.x,pt[8].x
				invoke SetWindowLong,hWnd,DC_DATA.ptDown.y,pt[8].y
				.if rv(GetAsyncKeyState,VK_CONTROL) & 8000h
					invoke GetWindowRect,hWnd,ADDR rect
					mov ebx,rv(GetParent,hWnd)
					invoke ScreenToClient,ebx,ADDR rect.left
					invoke ScreenToClient,ebx,ADDR rect.right
					mov ecx,pt.x
					mov edx,pt.y
					add rect.left,ecx
					add rect.top,edx
					add rect.right,ecx
					add rect.bottom,edx
					mov ecx,rect.right
					mov edx,rect.bottom
					sub ecx,rect.left
					sub edx,rect.top
					invoke MoveWindow,hWnd,rect.left,rect.top,ecx,edx,1
				.else
					mov ebx,rv(GetWindowLong,hWnd,DC_DATA.a)
					mov edx,rv(GetWindowLong,hWnd,DC_DATA.index)
					invoke ResizeCntrl,hWnd,edx,ebx,pt.x,pt.y
				.endif
			.endif
		.else
			invoke DefWindowProc,hWnd,uMsg,wParam,lParam
			ret
		.endif
	.elseif uMsg == WM_NCLBUTTONUP || uMsg == WM_LBUTTONUP
		.if rv(GetWindowLong,hWnd,DC_DATA.bDrag)
			invoke ReleaseCapture
			invoke SetWindowLong,hWnd,DC_DATA.bDrag,0
		.else
			invoke DefWindowProc,hWnd,uMsg,wParam,lParam
			ret
		.endif
	.elseif uMsg == WM_SIZE
		mov ebx,rv(GetWindowLong,hWnd,DC_DATA.a)
		invoke CreateRegion,hWnd,ebx
		invoke SetWindowRgn,hWnd,eax,1
		invoke GetClientRect,hWnd,ADDR rect
		mov ebx,rv(GetWindowLong,hWnd,DC_DATA.hCntrl)
		invoke MoveWindow,ebx,0,0,rect.right,rect.bottom,TRUE
	.elseif uMsg == WM_NCPAINT
		mov hdc,rv(GetWindowDC,hWnd)
		mov ebx,rv(GetWindowLong,hWnd,DC_DATA.a)
		invoke GetHandHoldsRect,hWnd,ebx,ADDR rect
		lea esi,rect
		xor edi,edi
		.while DWORD ptr edi < 8
			invoke Rectangle,hdc,[esi].RECT.left,[esi].RECT.top,[esi].RECT.right,[esi].RECT.bottom
			lea esi,[esi+SIZEOF RECT]
			lea edi,[edi+1]
		.endw
		invoke ReleaseDC,hWnd,hdc
	.else
		mov edx,rv(GetWindowLong,hWnd,DC_DATA.MSG_FORWARDING)
		.if uMsg == edx && edx
			.if wParam
				mov esi,wParam
				lea esi,[esi*4]
				mov edi,alloc(esi)
				invoke RtlMoveMemory,edi,lParam,esi
				invoke SetWindowLong,hWnd,DC_DATA.pMessages,edi
				invoke SetWindowLong,hWnd,DC_DATA.nMessages,wParam
			.else
				.if rv(GetWindowLong,hWnd,DC_DATA.pMessages)
					free eax
				.endif
				invoke SetWindowLong,hWnd,DC_DATA.pMessages,0
				invoke SetWindowLong,hWnd,DC_DATA.nMessages,0
			.endif
		.else
			invoke DefWindowProc,hWnd,uMsg,wParam,lParam
			ret
		.endif
	.endif

	xor eax,eax
	ret
DragContainer endp

align 16
BindContainer proc c uses edi esi ebx hDest:HWND,a:DWORD,hInst:HINSTANCE,nMessages:DWORD,uMessages:VARARG
LOCAL rect:RECT
LOCAL hWnd:HWND
	
	invoke GetWindowRect,hDest,ADDR rect
	mov ebx,rv(GetParent,hDest)
	invoke ScreenToClient,ebx,ADDR rect.left
	invoke ScreenToClient,ebx,ADDR rect.right
	mov ecx,rect.right
	mov edx,rect.bottom
	sub ecx,rect.left
	sub edx,rect.top
	mov eax,a
	lea eax,[eax*2]
	.if SDWORD ptr ecx < eax
		mov ecx,eax
	.endif
	.if SDWORD ptr edx < eax
		mov edx,eax
	.endif
	push ecx
	push edx
	mov hWnd,rv(CreateWindowEx,0,"DragContainer32",0,WS_VISIBLE or WS_CHILD or WS_CLIPCHILDREN or WS_CLIPSIBLINGS,rect.left,rect.top,ecx,edx,ebx,0,hInst,a)
	invoke SetParent,hDest,hWnd
	pop edx
	pop ecx
	mov eax,a
	lea eax,[eax*2]
	sub ecx,eax
	sub edx,eax
	invoke MoveWindow,hDest,0,0,ecx,edx,TRUE
	invoke SetWindowLong,hWnd,DC_DATA.hCntrl,hDest
	
	mov esi,rv(RegisterWindowMessage,"DCM_MSG_FORWARDING")
	.if nMessages
		invoke SendMessage,hWnd,esi,nMessages,ADDR uMessages
	.endif
	
	mov eax,hWnd
	ret
	
BindContainer endp

end main
